<html>
<head>
<title>Ogre::RenderQueueListener Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1RenderQueueListener.html">RenderQueueListener</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::RenderQueueListener Class Reference<div class="ingroups"><a class="el" href="group__RenderSystem.html">RenderSystem</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::RenderQueueListener" -->
<p>Abstract interface which classes must implement if they wish to receive events from the render queue.  
 <a href="classOgre_1_1RenderQueueListener.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreRenderQueueListener_8h_source.html">OgreRenderQueueListener.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::RenderQueueListener:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1RenderQueueListener__inherit__graph.gif" border="0" usemap="#Ogre_1_1RenderQueueListener_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1RenderQueueListener_inherit__map" id="Ogre_1_1RenderQueueListener_inherit__map">
<area shape="rect" id="node3" href="classOgre_1_1CompositorChain_1_1RQListener.html" title="Render queue listener used to set up rendering events." alt="" coords="5,83,237,112"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1RenderQueueListener-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RenderQueueListener.html#aca4ab8444c09caeeff186213a98beb89">~RenderQueueListener</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RenderQueueListener.html#aed637d7bad94336183321b5ee290751c">preRenderQueues</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Event raised before all render queues are processed.  <a href="#aed637d7bad94336183321b5ee290751c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RenderQueueListener.html#a0a6a53d54e3215fc2bf2c877fedd47d6">postRenderQueues</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Event raised after all render queues are processed.  <a href="#a0a6a53d54e3215fc2bf2c877fedd47d6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RenderQueueListener.html#a8996af861c202193c2bbb8db40e92722">renderQueueStarted</a> (<a class="el" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> queueGroupId, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;invocation, bool &amp;skipThisInvocation)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Event raised before a queue group is rendered.  <a href="#a8996af861c202193c2bbb8db40e92722"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RenderQueueListener.html#a338dd1abf82317692ce7504978c01a5c">renderQueueEnded</a> (<a class="el" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> queueGroupId, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;invocation, bool &amp;repeatThisInvocation)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Event raised after a queue group is rendered.  <a href="#a338dd1abf82317692ce7504978c01a5c"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Abstract interface which classes must implement if they wish to receive events from the render queue. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>The OGRE render queue is divided into several queue groups, as defined by uint8. A class may implement this interface, and register itself as a listener by calling <a class="el" href="classOgre_1_1SceneManager.html#ae60242c5d130f884cd605d3393186df6" title="Registers a new RenderQueueListener which will be notified when render queues are processed...">SceneManager::addRenderQueueListener</a>. After doing so, the class will receive an event before and after each queue group is sent to the rendering system. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>The event listeners have an option to make a queue either be skipped, or to repeat. Note that if multiple listeners are registered, the one registered last has the final say, although options set by previous listeners will not be changed if the latest does not express a preference. </dd></dl>

<p>Definition at line <a class="el" href="OgreRenderQueueListener_8h_source.html#l00056">56</a> of file <a class="el" href="OgreRenderQueueListener_8h_source.html">OgreRenderQueueListener.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="aca4ab8444c09caeeff186213a98beb89"></a><!-- doxytag: member="Ogre::RenderQueueListener::~RenderQueueListener" ref="aca4ab8444c09caeeff186213a98beb89" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1RenderQueueListener.html#aca4ab8444c09caeeff186213a98beb89">Ogre::RenderQueueListener::~RenderQueueListener</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreRenderQueueListener_8h_source.html#l00059">59</a> of file <a class="el" href="OgreRenderQueueListener_8h_source.html">OgreRenderQueueListener.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a0a6a53d54e3215fc2bf2c877fedd47d6"></a><!-- doxytag: member="Ogre::RenderQueueListener::postRenderQueues" ref="a0a6a53d54e3215fc2bf2c877fedd47d6" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RenderQueueListener.html#a0a6a53d54e3215fc2bf2c877fedd47d6">Ogre::RenderQueueListener::postRenderQueues</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Event raised after all render queues are processed. </p>

<p>Definition at line <a class="el" href="OgreRenderQueueListener_8h_source.html#l00066">66</a> of file <a class="el" href="OgreRenderQueueListener_8h_source.html">OgreRenderQueueListener.h</a>.</p>

</div>
</div>
<a class="anchor" id="aed637d7bad94336183321b5ee290751c"></a><!-- doxytag: member="Ogre::RenderQueueListener::preRenderQueues" ref="aed637d7bad94336183321b5ee290751c" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RenderQueueListener.html#aed637d7bad94336183321b5ee290751c">Ogre::RenderQueueListener::preRenderQueues</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Event raised before all render queues are processed. </p>

<p>Definition at line <a class="el" href="OgreRenderQueueListener_8h_source.html#l00063">63</a> of file <a class="el" href="OgreRenderQueueListener_8h_source.html">OgreRenderQueueListener.h</a>.</p>

</div>
</div>
<a class="anchor" id="a338dd1abf82317692ce7504978c01a5c"></a><!-- doxytag: member="Ogre::RenderQueueListener::renderQueueEnded" ref="a338dd1abf82317692ce7504978c01a5c" args="(uint8 queueGroupId, const String &amp;invocation, bool &amp;repeatThisInvocation)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RenderQueueListener.html#a338dd1abf82317692ce7504978c01a5c">Ogre::RenderQueueListener::renderQueueEnded</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>&#160;</td>
          <td class="paramname"><em>queueGroupId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>invocation</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool &amp;&#160;</td>
          <td class="paramname"><em>repeatThisInvocation</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Event raised after a queue group is rendered. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This method is called by the <a class="el" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a> after each queue group is rendered. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">queueGroupId</td><td>The id of the queue group which has just been rendered </td></tr>
    <tr><td class="paramname">invocation</td><td>Name of the invocation which is causing this to be called (</td></tr>
  </table>
  </dd>
</dl>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RenderQueueInvocation.html" title="Class representing the invocation of queue groups in a RenderQueue.">RenderQueueInvocation</a>) </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">repeatThisInvocation</td><td>A boolean passed by reference which is by default set to false. If the event sets this to true, the queue which has just been rendered will be repeated, and the renderQueueStarted and renderQueueEnded events will also be fired for it again. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1CompositorChain_1_1RQListener.html#a6bae4a9e3da5f047168f3e703066c422">Ogre::CompositorChain::RQListener</a>.</p>

<p>Definition at line <a class="el" href="OgreRenderQueueListener_8h_source.html#l00096">96</a> of file <a class="el" href="OgreRenderQueueListener_8h_source.html">OgreRenderQueueListener.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8996af861c202193c2bbb8db40e92722"></a><!-- doxytag: member="Ogre::RenderQueueListener::renderQueueStarted" ref="a8996af861c202193c2bbb8db40e92722" args="(uint8 queueGroupId, const String &amp;invocation, bool &amp;skipThisInvocation)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RenderQueueListener.html#a8996af861c202193c2bbb8db40e92722">Ogre::RenderQueueListener::renderQueueStarted</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>&#160;</td>
          <td class="paramname"><em>queueGroupId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>invocation</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool &amp;&#160;</td>
          <td class="paramname"><em>skipThisInvocation</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Event raised before a queue group is rendered. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This method is called by the <a class="el" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a> before each queue group is rendered. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">queueGroupId</td><td>The id of the queue group which is about to be rendered </td></tr>
    <tr><td class="paramname">invocation</td><td>Name of the invocation which is causing this to be called (</td></tr>
  </table>
  </dd>
</dl>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RenderQueueInvocation.html" title="Class representing the invocation of queue groups in a RenderQueue.">RenderQueueInvocation</a>) </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">skipThisInvocation</td><td>A boolean passed by reference which is by default set to false. If the event sets this to true, the queue will be skipped and not rendered. Note that in this case the renderQueueEnded event will not be raised for this queue group. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1CompositorChain_1_1RQListener.html#a0fa10cc7b6d0db12d05f20e6d110fa33">Ogre::CompositorChain::RQListener</a>.</p>

<p>Definition at line <a class="el" href="OgreRenderQueueListener_8h_source.html#l00080">80</a> of file <a class="el" href="OgreRenderQueueListener_8h_source.html">OgreRenderQueueListener.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreRenderQueueListener_8h_source.html">OgreRenderQueueListener.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:03
</p>
</body>
</html>
